InGameGizmo = {}
InGameGizmo.ModDirectory = g_currentModDirectory
InGameGizmo.ModName = g_currentModName


function InGameGizmo:ConstructionBrushUpdate()
    if self.cursor ~= nil then InGameGizmo.cursor = self.cursor; end
   
    if InGameGizmo.AxisModifier and InGameGizmo.LastHit and InGameGizmo.CurrentPlaceable and InGameGizmo.GizmoNode then

        local MoveDistance = { 
            x =  (InGameGizmo.cursor.currentHitX - InGameGizmo.LastHit.x) * InGameGizmo.AxisModifier.x,
            y =  (InGameGizmo.cursor.currentHitY - InGameGizmo.LastHit.y) * InGameGizmo.AxisModifier.y,
            z =  (InGameGizmo.cursor.currentHitZ - InGameGizmo.LastHit.z) * InGameGizmo.AxisModifier.z
        }

        InGameGizmo.LastHit = {
            x = InGameGizmo.cursor.currentHitX,
            y = InGameGizmo.cursor.currentHitY,
            z = InGameGizmo.cursor.currentHitZ
        }

        if InGameGizmo.Rotate then 
            InGameGizmo.CurrentPlaceable.rotation.x = InGameGizmo.CurrentPlaceable.rotation.x + MoveDistance.x;
            InGameGizmo.CurrentPlaceable.rotation.y = InGameGizmo.CurrentPlaceable.rotation.y + MoveDistance.y;
            InGameGizmo.CurrentPlaceable.rotation.z = InGameGizmo.CurrentPlaceable.rotation.z + MoveDistance.z;
        else
            InGameGizmo.CurrentPlaceable.position.x = InGameGizmo.CurrentPlaceable.position.x + MoveDistance.x;
            InGameGizmo.CurrentPlaceable.position.y = InGameGizmo.CurrentPlaceable.position.y + MoveDistance.y;
            InGameGizmo.CurrentPlaceable.position.z = InGameGizmo.CurrentPlaceable.position.z + MoveDistance.z;
        end

        InGameGizmo.CurrentPlaceable:initPose();

        setTranslation(InGameGizmo.GizmoNode, InGameGizmo.CurrentPlaceable.position.x, InGameGizmo.CurrentPlaceable.position.y,InGameGizmo.CurrentPlaceable.position.z);
    end
end

function InGameGizmo:MouseDown(Button)
    local HitNode = InGameGizmo.cursor:getHitNode()

    if HitNode == nil then return; end
    local HitName = getName(HitNode)

    if HitName == "GizmoX" then InGameGizmo.AxisModifier = {x = 1, y = 0, z = 0}; end 
    if HitName == "GizmoY" then InGameGizmo.AxisModifier = {x = 0, y = 1, z = 0}; end
    if HitName == "GizmoZ" then InGameGizmo.AxisModifier = {x = 0, y = 0, z = 1}; end

    if InGameGizmo.AxisModifier == nil then return; end;   

    InGameGizmo.LastHit = {
        x = InGameGizmo.cursor.currentHitX,
        y = InGameGizmo.cursor.currentHitY,
        z = InGameGizmo.cursor.currentHitZ
    }
    InGameGizmo.Rotate = Button == 3;
end

function InGameGizmo:MouseUp() 
    InGameGizmo.AxisModifier = nil;
    InGameGizmo.LastHit = nil;
end

function InGameGizmo:MouseEvent(posX, posY, isDown, isUp, button, eventUsed) 
    
    InGameGizmo.ConstructionScreen = self;

    if isDown then
        InGameGizmo:MouseDown(button);
    end

    if isUp then
        InGameGizmo:MouseUp();
    end
end

function InGameGizmo:Deactivate(...)
    if InGameGizmo.ConstructionScreen ~= nil then
    InGameGizmo.ConstructionScreen.inputManager:setActionEventText(InGameGizmo.ConstructionScreen.backButtonEvent, g_i18n:getText("input_CONSTRUCTION_EXIT"));
    end

    if InGameGizmo.GizmoNode ~= nil then
        setTranslation(InGameGizmo.GizmoNode, 0,-100,0);
         setVisibility(InGameGizmo.GizmoNode, false);
    end

    InGameGizmo.CurrentPlaceable = nil;
    InGameGizmo.AxisModifier = nil;
    InGameGizmo.LastHit = nil;
end

function InGameGizmo:PlaceableSelected(CurrentPlaceable)
    InGameGizmo.ConstructionScreen.inputManager:setActionEventText(InGameGizmo.ConstructionScreen.backButtonEvent, g_i18n:getText("button_back"));

    InGameGizmo.CurrentPlaceable = CurrentPlaceable;

    if InGameGizmo.GizmoNode == nil then
        InGameGizmo.GizmoNode = loadI3DFile(InGameGizmo.ModDirectory .."Gizmos.i3d");
        if InGameGizmo.GizmoNode then link(getRootNode(), InGameGizmo.GizmoNode) end
    end

    setTranslation(InGameGizmo.GizmoNode, CurrentPlaceable.position.x, CurrentPlaceable.position.y, CurrentPlaceable.position.z);
    setVisibility(InGameGizmo.GizmoNode, true);
end

function InGameGizmo:ClickButton() 
    self:onClickBack()
    InGameGizmo:PlaceableSelected(self.placeable);
end

function InGameGizmo:InsertMoveButton() 
    InGameGizmo:Deactivate()

    if self.MoveButton ~=nil then return; end;

    local function createBtn(prefab, text, callback)
		local btn = prefab:clone(prefab.parent)
		btn:setText(text)
		btn:setVisible(false)
		btn:setCallback("onClickCallback", callback)
        btn:setInputAction(InputAction.MENU_EXTRA_1)
		btn.parent:invalidateLayout()
		return btn
	end

    self.MoveButton = createBtn(self.renameButton, g_i18n:getText("button_move"), "onClickMove");
    self.MoveButton:setVisible(true)
end

function InGameGizmo:ButtonMenuBack(OldFunc,...) 
    if InGameGizmo.CurrentPlaceable ~= nil then InGameGizmo:Deactivate(); return; end
    return OldFunc(self,...);
end

PlaceableInfoDialog.onClickMove = Utils.prependedFunction(PlaceableInfoDialog.onClickMove, InGameGizmo.ClickButton);
PlaceableInfoDialog.setPlaceable = Utils.prependedFunction(PlaceableInfoDialog.setPlaceable, InGameGizmo.InsertMoveButton);

ConstructionScreen.mouseEvent = Utils.prependedFunction(ConstructionScreen.mouseEvent, InGameGizmo.MouseEvent);
ConstructionScreen.onButtonMenuBack = Utils.overwrittenFunction(ConstructionScreen.onButtonMenuBack, InGameGizmo.ButtonMenuBack);

ConstructionScreen.setBrush = Utils.appendedFunction(ConstructionScreen.setBrush, InGameGizmo.Deactivate);

ConstructionBrushSelect.update = Utils.prependedFunction(ConstructionBrushSelect.update, InGameGizmo.ConstructionBrushUpdate);

addModEventListener(InGameGizmo);
